local gr = love.graphics

function love.load()

	screen = { x=400, y=400 }
	love.window.setMode( screen.x, screen.y )
	love.window.setTitle( 'Push & Pop' )
	angle	= 0
	rect	= { w=100, h=20 }
	ell		= { w=100, h=40 }

	end

function love.update( dt )

	angle = angle + dt

	end

function love.draw()

	gr.setColor( 255, 222, 255 )
	gr.circle( 'fill', screen.x/2, screen.y/2, 5 )	-- show center at 200,200

	gr.push()

		gr.translate( screen.x/2, screen.y/2 )		-- draw everything relative to 0,0 and offset by 200,200
		gr.rotate( angle )
		gr.line( -ell.w, 0, ell.w, 0 )				-- actual (100,200)-(300,200) rotating around 200,200
		gr.ellipse( 'line', 0, 0, ell.w, ell.h )	-- actual center at (200,200)
		gr.setColor( 0, 255, 0 )
		gr.circle( 'line',  ell.w, 0, 10 )			-- outer edge of ellipse
		gr.circle( 'line', -ell.w, 0, 10 )			-- inner edge pf ellipse
		gr.line( 0, -ell.h, 0, ell.h )				-- actual (200,160)-(200,240) rotating around 200,200
		gr.circle( 'line', 0,  ell.h, 10 )
		gr.circle( 'line', 0, -ell.h, 10 )

		gr.setColor( 0, 0, 255 )
		gr.rotate( -2*angle )						-- rotate by -angle
		gr.rectangle( 'line', -rect.w/2, -rect.h/2, rect.w, rect.h )	-- centers rectangle 200,200
		gr.rectangle( 'line', -rect.h/2, -rect.w/2, rect.h, rect.w )
		gr.setColor( 255, 0, 0 )
		gr.circle( 'line', 0, 0, 10 )

		gr.pop()

	end

function love.keypressed( key )

	if key == "escape"	then love.event.quit() end

	end
